SystemOrganization addCategory: #'Xen-Tests'!

Trait named: #TFoo
	uses: {}
	category: 'Xen-Tests'!

!TFoo commentStamp: 'NolanVoid 5/23/2014 07:55' prior: 0!
A TFoo is a test trait.
!

Object subclass: #ButtonTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!ButtonTest1 commentStamp: 'NolanVoid 5/1/2014 18:50' prior: 0!
A ButtonTest is a test that creates a button and opens a Transcript. When the button is clicked, a message appears in the Transacript.
!

!ButtonTest1 methodsFor: 'initialization' stamp: 'NolanVoid 5/5/2014 00:16'!
initialize
	"Open a Transcript and create a button."

	Transcript openLabel: 'Xen-Tests'.
	XTButton new.
! !

Object subclass: #ButtonTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!ButtonTest2 commentStamp: 'NolanVoid 5/1/2014 18:50' prior: 0!
A ButtonTest is a test that creates a button and opens a Transcript. When the button is clicked, a message appears in the Transacript.
!

!ButtonTest2 methodsFor: 'initialization' stamp: 'NolanVoid 5/4/2014 01:35'!
initialize
	"Open a Transcript and create a button."

	Transcript openLabel: 'Xen-Tests: targeted'.
	XTTargetButton new.
! !

Object subclass: #XenNumTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenNumTests commentStamp: 'NolanVoid 5/20/2014 10:02' prior: 0!
Number tests.
!

!XenNumTests class methodsFor: 'math' stamp: 'NolanVoid 5/20/2014 10:35'!
bounce
	"Explore bouncing function values"

	| |
	Transcript openLabel: 'Bouncing function values'.
	Transcript clear.
	-1 to: 1 by: 0.1 do:
		[ :each|
			| x y |
			x := each.
			y := x raisedTo: 0.5 * x.
			y := y round: 14.
			Transcript show: y ; cr].! !

!XenNumTests class methodsFor: 'math' stamp: 'NolanVoid 5/20/2014 10:10'!
piCount
	"Count up by pi"

	| negpi pospi |
	negpi := (Float pi) negated.
	pospi := (Float pi).
	Transcript openLabel: 'Xen Number Tests'.
	Transcript clear.
	negpi to: pospi by: pospi/4 do: [ :each| Transcript show: each sin; cr].! !

Object subclass: #XenaSpace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XenaSpace commentStamp: 'NolanVoid 5/23/2014 08:10' prior: 0!
A XenaSpace is basically just a namespace for playing around with variables and whatnot.
!

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:16'!
bar
	"Outer function."
	| x y |
	x := 5.
	y := 6.
	^  self foo value

! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:14'!
foo
	"Inner function."
	| x y |
	x := 3.
	y := 4.
	^  [x + y]

! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 00:06'!
lexicalClosure
	"Demonstrate a lexical closure as a lambda."

	| x y |
	x := 3.
	y := 4.
	^ [x + y] value! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 06:42'!
loopTest
	"Basic loop test."
	
	| n |
	n := 1.
	[ n <1000 ] whileTrue: [ n := n*2 ].
	^ n! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 06:50'!
loopTest2
	"Basic loop test."
	
	| n |
	n := 1.
	10 timesRepeat: [ n := n*2 ].
	^ n! !

!XenaSpace class methodsFor: 'mapping' stamp: 'NolanVoid 5/7/2014 07:20'!
mapping1
	"Collect mapping"

	^ (1 to: 10) collect: [:n| n*n]! !

!XenaSpace class methodsFor: 'mapping' stamp: 'NolanVoid 5/7/2014 07:23'!
selectMap
	"Select mapping"

	^ 'hello there' select: [ :char | char isVowel ]! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/4/2014 21:03'!
simpleClosure
	"Return a simple closure."

	| x y |
	x := 3.
	y := 4.
	^ [x + y]! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 07:05'!
tobydoLoop
	"Basic loop test."
	
	| result |
	result := String new.
	1 to: 10 by: 0.3 do: [:n | result := result, n printString, ' '].
	^ result
	! !

!XenaSpace class methodsFor: 'loops' stamp: 'NolanVoid 5/7/2014 07:05'!
todoLoop
	"Basic loop test."
	
	| result |
	result := String new.
	1.3 to: 10 do: [:n | result := result, n printString, ' '].
	^ result
	! !

!XenaSpace class methodsFor: 'closures' stamp: 'NolanVoid 5/7/2014 01:00'!
whatsis
	"Demonstrate a dynamic closure as a lambda."

	| x y foo |
	x := 3.
	y := 4.
	foo :=  [x + y].
	x := 5.
	y := 6.
	^ foo value! !

SimpleButtonMorph subclass: #XTButton
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XTButton commentStamp: 'NolanVoid 5/1/2014 19:08' prior: 0!
A XTButton is a widget that prints a message in the Transcript.
!

!XTButton methodsFor: 'initialization' stamp: 'NolanVoid 5/5/2014 00:16'!
initialize
	"Set up the button."

	super initialize.
	self
		bottomLeft: 60@200;
		color: (Color r: 0.6 g: 1.0 b: 0.8 alpha: 1.0);
		label: 'Send message';
		helpText: 'Click me to send a message to the Transcript';
		openInWorld
! !

!XTButton methodsFor: 'event handling' stamp: 'NolanVoid 5/5/2014 00:14'!
mouseUp: evt
	"Send a message to the Transcript."

	super mouseUp: evt.
	Transcript show: 'Magical message!!'; cr! !

SimpleButtonMorph subclass: #XTTargetButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xen-Tests'!

!XTTargetButton commentStamp: 'NolanVoid 5/4/2014 01:35' prior: 0!
A XTTargetButton is a button that sends its target (a Transcript) a message.
!

!XTTargetButton methodsFor: 'initialization' stamp: 'NolanVoid 5/5/2014 00:10'!
initialize
	"Set up the button."

	super initialize.
	self
		bottomLeft: 60@200;
		color: (Color r: 0.6 g: 1.0 b: 0.8 alpha: 1.0);
		label: 'Send message';
		helpText: 'Click me to send a message to the Transcript';
		target: Transcript;
		actionSelector: #show:;
		arguments: {'Magic targeted message!!', Character cr asString};
		openInWorld! !
